function ExperienceAssign(unit, target, kills, casualties)
--LogUi("EXP START")
local attlevel = 0
local  deflevel = 0

attlevel = GetUnitExperienceLevel(unit) +1
deflevel = GetUnitExperienceLevel(target) +1
--LogUi("A/D" .. attlevel .. "/" .. deflevel)


   if unit.luaData.experience == nil then
     unit.luaData.experience = 0
   end
   if target.luaData.experience == nil then
     target.luaData.experience = 0
   end
   
   
local factor = 1
if unit.prototype.name == "artillery" 
	or (unit.type == Unit.NAVAL and unit.alliance.id == player.alliance.id) then
	factor = 0.35
end
unit.luaData.experience = unit.luaData.experience + (((kills  - casualties) *  1/(attlevel/deflevel)) * factor)



if unit.luaData.experience <= 0 then
	unit.luaData.experience = 0
end
--LogUi("EXP END")
end


-- Should be called AFTER repairing the points
function ExperienceRepair(unit, repairPoints)
  local maxHp = 100
if unit.luaData.experience == nil then
unit.luaData.experience = 0
end
  -- 20% of experience is passsed on to new replacements
  local bonus = math.floor(repairPoints * unit.luaData.experience / 5)

  unit.luaData.experience = math.floor((unit.luaData.experience * (unit.hp - repairPoints) + bonus) / unit.hp)
end

function GetUnitExperience(unit)

  if unit.luaData.experience == nil then
    unit.luaData.experience = 0
  end

  return unit.luaData.experience

end

function GetUnitExperienceLevel(unit)
  local exp = GetUnitExperience(unit)
  
  if exp == nil then
	return 0
  end
  if exp < 100 then
    return 0
  elseif exp < 200 then
    return 1
  elseif exp < 300 then
    return 2
  else
    return 3
  end
end


function GetUnitExperienceBonus(unit)
local explevel = GetUnitExperienceLevel(unit)

if explevel == 0 then
return 0
elseif explevel == 1 then
return 0.1
elseif explevel == 2 then
return 0.2
elseif explevel == 3 then
return 0.3
end
end


