gameplay.moraleSurrenderBase = 0

function InitMorale()
  for faction in game.factions do
    InitMoraleFaction(faction)
  end

  MoraleCalculation()
end

function InitMoraleFaction(faction)
  faction.luaData.moraleLevel = GetMoraleLevel(0, faction.morale)
  faction.luaData.eventMorale = faction.morale
end


function MoraleCalculation()

  -- Events
  -- City loss (minor effect)
  -- Army strength VS max army strength (strong effect)
  -- Kills/Casualties (modifier to army strength > the worse army performs, the weaker the effect of army strength)
  -- Total Morale = sum of all above

  -- Handle new Factions
--~   if faction.luaData.moraleLevel == nil then
--~     InitMoraleFaction(faction)
--~   end

  for alliance in game.alliances do
    if alliance.id ~= 0 then
      for faction in alliance.factions do
        FactionMoraleCalculation(faction)
      end
    end
  end

 -- 
 if game.turn <=1 then
 LogUi("START PRE-GAME LUA DEFINITIONS")
local entente =  game:GetAllianceById(1)
local cp =  game:GetAllianceById(2)
 
local france = game:GetFactionById(0)
local britain = game:GetFactionById(1)
local germany = game:GetFactionById(2)
local austria = game:GetFactionById(3)
local russia = game:GetFactionById(4)
local turkey = game:GetFactionById(5)
local belgium = game:GetFactionById(6)


local serbia = game:GetFactionById(7)
local italy = game:GetFactionById(8)
local usa = game:GetFactionById(10)
local bulgaria = game:GetFactionById(19)
local romania = game:GetFactionById(18)
local portugal = game:GetFactionById(16)
local greece = game:GetFactionById(14)
local netherlands = game:GetFactionById(9)
local sweden = game:GetFactionById(11)

local persia = game:GetFactionById(22)
local impassable = game:GetFactionById(24)




--[[local sfx = {}
    sfx = LoadSample("Radio.wav")
	PlaySample(sfx)
	PlaySample(LoadSample("Radio.wav"))
	Soundeffekt = "Radio"
]]

--potzstart
------- start definitions
--math.randomseed( os.time() )

	math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();
	math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();
	math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();
	math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();
	math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();
	math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();	
  local aluck = math.random(1,100)
  local bluck = math.random(1,100)
  local cluck = math.random(1,100)


austria.luaData.startdp = math.random(3,6)   ---(4,9)  -- testing 
if game.difficulty == 4 then
	austria.luaData.startdp = austria.luaData.startdp +2
end	
serbia.luaData.startdp = math.random(1,3) + math.random(1,3) 

	
france.luaData.collaps = 0
britain.luaData.collaps = 0	
germany.luaData.collaps = 0
austria.luaData.collaps = 0	
italy.luaData.collaps = 0
russia.luaData.collaps = 0
turkey.luaData.collaps = 0

---------------------------------------------


turkey.luaData.deserts = -30
greece.luaData.startalign = greece.luaData.alignment

france.luaData.convoysarrived = 0
britain.luaData.convoysarrived = 0

france.luaData.deadcommander = 1
britain.luaData.deadcommander = 1	
germany.luaData.deadcommander = 1
austria.luaData.deadcommander = 1	
russia.luaData.deadcommander = 1
turkey.luaData.deadcommander = 1
italy.luaData.deadcommander = 1

france.luaData.extralab = 0
britain.luaData.extralab = 0	
germany.luaData.extralab = 0
austria.luaData.extralab = 0	
russia.luaData.extralab = 0
italy.luaData.extralab = 0


france.luaData.workforce = 0
britain.luaData.workforce = 0	
germany.luaData.workforce = 0
austria.luaData.workforce = 0	
russia.luaData.workforce = 0
italy.luaData.workforce = 0


france.luaData.outcome = -1

britain.luaData.abadancounter = 0
britain.luaData.britishsupply = 5
britain.luaData.sunk = 0
britain.luaData.kitchener = 0
britain.luaData.sunkconvoys = 0
britain.luaData.transtosouth = 0
britain.luaData.suezcanalblock = 0
britain.luaData.blockadestrength = 0
britain.luaData.straits = 3
britain.luaData.senussiend = 0
britain.luaData.pacific = math.random(80,120)
britain.luaData.lusitania = 0
britain.luaData.befcorps = 0
britain.luaData.canadiancorps = 0
britain.luaData.grafspee = 0
britain.luaData.kuwait = 0
britain.luaData.rfzep = math.random(1,100)

turkey.luaData.uprisings = 0
turkey.luaData.senussi = 0
turkey.luaData.arabs = 0
turkey.luaData.enver = 0
turkey.luaData.hasgoeben = 0

usa.luaData.recentconvoy = 0
usa.luaData.mexico = 0
usa.luaData.flucounter = math.random(2,8)
usa.luaData.fluchance = math.random(40,80)

serbia.luaData.russianhelp = 0

germany.luaData.advance = 0
germany.luaData.blockaded = 0
germany.luaData.germanstop = 0
germany.luaData.northblockcounter = 0
germany.luaData.pritt = 0
germany.luaData.maxinfrance = 0
germany.luaData.infrance = 0
germany.luaData.franceadvance = 0
germany.luaData.franceadvanceold = 0
germany.luaData.techbehind = 0
germany.luaData.russkills = 0
germany.luaData.harvest = 9
germany.luaData.misharvest = 0
germany.luaData.boredfleet = 0
germany.luaData.activefleet = 2
germany.luaData.blockadebreak = 0
germany.luaData.tsingtao = 0
germany.luaData.kaisernew = 0
germany.luaData.kaiserold = 0
germany.luaData.sunk = 0
germany.luaData.pacific = 1
germany.luaData.funk = 0
germany.luaData.francoisluck = math.random(1,10)
germany.luaData.francois = 0
germany.luaData.masuria = 0
germany.luaData.germansinfrance = 0
germany.luaData.wassmuss = 0
germany.luaData.wassluck = math.random(1,100)
germany.luaData.francesurprise = math.random(1,6)
germany.luaData.boredfleet = 0
germany.luaData.kaiserroll = math.random(1,8)
germany.luaData.kaiserhero = math.random(1,3)
germany.luaData.schlieffenluck = math.random(1,100)
germany.luaData.goebenship = 0
germany.luaData.eastwait = math.random(5,6)
germany.luaData.subsgone = 0
germany.luaData.bridges  = 12
germany.luaData.bridgeok = 0
germany.luaData.kaisergold = 0.2 * math.random(1,10)
germany.luaData.marinekorps = 0
germany.luaData.inbelgium = 0
germany.luaData.africalost = math.random(15, 25)
germany.luaData.passage = math.random(1,100)
germany.luaData.eastchoice = 0


austria.luaData.howitzers = 0
austria.luaData.keepguns = math.random(1,10)
austria.luaData.subs = 0
austria.luaData.goebenspawn = 0
austria.luaData.planning = math.random(1,100)

netherlands.luaData.food = 10


belgium.luaData.caninfluence = 0
impassable.luaData.coast = 0
--impassable.luaData.reload = 0


serbia.luaData.invasion = 0

austria.luaData.techbehind = 0
austria.luaData.czechs = 0
austria.luaData.croats = 0
austria.luaData.hungarians = 0
austria.luaData.reformchance =  math.random(1,100)
austria.luaData.bohm = 0
austria.luaData.romania = 0

cp.luaData.alpine = 0
entente.luaData.alpine = 0


cp.luaData.negoti = 0
entente.luaData.negoti = 0

italy.luaData.cadornadead = 0
italy.luaData.cadornacharge = 0
italy.luaData.side = 0
italy.luaData.joincp = math.random(10,14)
italy.luaData.swing = math.random(1,3)
italy.luaData.tunisia = 0


serbia.luaData.typhcounter = 0
serbia.luaData.russianhelp = 0

belgium.luaData.surrenderchance = math.random(1,100)
serbia.luaData.surrenderchance = math.random(1,100)

germany.luaData.diplopokerchance = math.random(1,100)
germany.luaData.kaiserschlacht = 0
germany.luaData.swedenpact = math.random(1,100)
germany.luaData.swedenpacttwo = math.random(1,12)
sweden.luaData.swedenchance = math.random(5,10)
sweden.luaData.fleetloss = 0
germany.luaData.goebenblocked = 0
germany.luaData.tirpitz = 0
germany.luaData.tirpitzai = math.random(1,100)

germany.luaData.orient = math.random(1,100)
germany.luaData.asia = math.random(2,3)

russia.luaData.surprisechance = math.random(1,100)
russia.luaData.plan = 0

turkey.luaData.dardaclosed = math.random(1,100)


austria.luaData.hotzattack = math.random(1,100)
austria.luaData.hotzmulti = math.random(2,4)
austria.luaData.poker = math.random(1,8)
austria.luaData.trieste = 0




serbia.luaData.typhoidchance = math.random(1,100)
serbia.luaData.typhoidmultia = math.random(2,4)
serbia.luaData.typhoidmultib = math.random(1,4)

usa.luaData.elections = math.random(1,10)
usa.luaData.propaganda = math.random(1,4)
usa.luaData.borderwar = math.random(75,95)

serbia.luaData.help = math.random(6,9)

russia.luaData.samso = 0
russia.luaData.code = 0
russia.luaData.mines = 0
russia.luaData.crisis = 100
russia.luaData.rasputin = math.random(2,5)
russia.luaData.steamroller = 0
russia.luaData.bonushex = 0
russia.luaData.ingermany = 0
russia.luaData.inaustria = 0
russia.luaData.kornilov = math.random(1,6)
russia.luaData.leninluck = math.random(1,6)
russia.luaData.obstinacy = 0
russia.luaData.blackdread = 0
russia.luaData.hasdread = 0
russia.luaData.hastransport = 0
russia.luaData.tabriz = 0
russia.luaData.tabriztwo = math.random(5,20)
russia.luaData.finland = 0
russia.luaData.october = math.random(3,5)
russia.luaData.startcivwar = 0 
russia.luaData.kornilovkill = 0
russia.luaData.yudenichkill = 0
russia.luaData.kolchakkill = 0
russia.luaData.delay = math.random(2,3)
russia.luaData.evert = 0
russia.luaData.brussilow = 0
russia.luaData.polivanov = math.random(3,5)
russia.luaData.february = math.random(2,5)
russia.luaData.kaputt = math.random(8,12)
russia.luaData.kerenski = 0

france.luaData.outrance = 1
france.luaData.attaque = 0
france.luaData.revenge = 0
france.luaData.attaqueluck = math.random(4,8)
france.luaData.joffreattack = 0
france.luaData.somme = 0
france.luaData.sommeends = 0
france.luaData.sommeparis = 1
france.luaData.sommeverdun = 1
france.luaData.taxis = 0
france.luaData.gallieni = 0
france.luaData.maghreb = math.random(10,20)
france.luaData.railluck = math.random(1,100)
france.luaData.legion = 0
france.luaData.africa = 0
france.luaData.verdunattack = math.random(1,5)
france.luaData.michel = 0
france.luaData.yser = 0
france.luaData.veracruz = 0





britain.luaData.oilfields = 0
britain.luaData.oilfieldstwo = 0
britain.luaData.kiwis = 0
britain.luaData.rfc = 0
britain.luaData.tanks = 0
britain.luaData.irish = 0
britain.luaData.mines = 0
germany.luaData.minesnorthsea = 0
germany.luaData.minesbaltic = 0
germany.luaData.tradesub = 0
britain.luaData.ottomansattack = 0
britain.luaData.swinton = math.random(6,12)
britain.luaData.galli = math.random(15,30)

romania.luaData.announcement = 0
romania.luaData.oldalignment = 0
romania.luaData.king = math.random(5,20)
romania.luaData.winover = math.random(51,66)
bulgaria.luaData.trenches = 0



persia.luaData.side = 0


local entente =  game:GetAllianceById(1)
entente.luaData.DP = 0 

local cp =  game:GetAllianceById(2)
cp.luaData.DP = 0

entente.luaData.ambassadors = 0
cp.luaData.ambassadors = 0

cp.luaData.hoffmann = 0

cp.luaData.persia = 0

for faction in game.factions do
	faction.luaData.labsforfree = 0
end

entente.luaData.eventsplayed = 0
cp.luaData.eventsplayed = 0

entente.luaData.luckyhit = 0
cp.luaData.luckyhit = 0

entente.luaData.diplomats = 0
cp.luaData.diplomats = 0

entente.luaData.negot = 0
cp.luaData.negot = 0

entente.luaData.ammoboom = math.random(1,100)
cp.luaData.ammoboom = math.random(1,100)

cp.luaData.austriansubs = 0

cp.luaData.squabbel = 0

entente.luaData.scandal = 0
cp.luaData.scandal = 0

entente.luaData.winning = 0
cp.luaData.winning = 0

entente.luaData.cpminesspot = 0
cp.luaData.entminesspot = 0

entente.luaData.eventcounter = 0
cp.luaData.eventcounter = 0

entente.luaData.ammosound = 0
cp.luaData.ammosound = 0

entente.luaData.railsound = 0
cp.luaData.railsound = 0

entente.luaData.transportsound = 0
cp.luaData.transportsound = 0

cp.luaData.seatransfers = 0
entente.luaData.seatransfers = 0

entente.luaData.suez = 0

entente.luaData.ingermany = 0

entente.luaData.convoyfactor = 0.1 * (math.random(1,10))
cp.luaData.convoyfactor = 0.1 * (math.random(1,10))


cp.luaData.warprop = 0

entente.luaData.searace = 0
cp.luaData.searace = 0

entente.luaData.verdun = 0
cp.luaData.verdun = 0

entente.luaData.pillage = 0
cp.luaData.pillage = 0

entente.luaData.socialists = 0
cp.luaData.socialists = 0


cp.luaData.infiltrated = 0
entente.luaData.infiltrated = 0
----choices
cp.luaData.stuff = 0
entente.luaData.stuff = 0

entente.luaData.eventlist = {"BritishGuarantee", "FrenchArmyOfAfrica", "ItalyLeaves", "RussiaMob", "SerbiaHelp", "Spithead", "TurkBB", "UltimatumSerbia3"} -- 8
cp.luaData.eventlist      = {"DiplomaticPoker","KaiserGold", "Tirpitz", "Howitzers", "PPBonus", "UltimatumBelgium", "UltimatumSerbia", "AmmoBonus"} -- 8
--- german AI warplans removed from probability tables because of new difficulty options

entente.luaData.brokencp = {}
cp.luaData.brokenent = {}

entente.luaData.topevents = {"AbadanOccupy", "AustralianNewZealandCorps",  "CanadianCorps","DiploBonus2", "Dannunzio", "FrenchArmyOfAfrica","NorthSeaBlockade", "Bef", "BritishGuarantee", "Evert", "ForeignLegion", "Gallieni", "GallipoliStraits","ItalyLeaves", "JapanWar", "Kornilov", "Lusitania", "Polivanov", "RomaniaKing", "SalonikaDonation", "Taxis", "TunisiaCeded", "VerdunOne"}
entente.luaData.highevents = {"ArabianRevolt", "BlockadeFormed","Clemenceau", "FrenchTrench", "Germanophobia",  "GrafSpeeSunk", "GreeceCoup",  "InvadeBelgium", "Kerenski",  "KuwaitRevolt", "LeninShot",  "Michel", "MurmanConvoys", "MurmanRailway","Pipeline","RailroadSabotage",  "RussiaAttack", "RussiaSurprise", "RussiaMob",  "Scandal",  "SenussiEnd",  "SevereBlockade",  "Spy2",  "UltimatumSerbia3",  "VeraCruz",  "WarPropaganda",  "WarPropagandaRomania", "WarPropagandaTwo"}
entente.luaData.medevents = {"BritishConscription",  "Brussilow", "ColmarDeath", "DutchCrisis1",  "Masaryk", "PalsBattalions", "PersianBorderEnt",  "ScottishWomen",  "SerbiaHelp",  "Spy3",  "TurkBB"}
----------------------------------------------------------------------
cp.luaData.topevents = {"BulgariaAttack", "BrestLitovTreaty", "BrestLitovTreaty2","CpMoralLow", "DiploBonus", "DiplomaticPoker", "Goeben", "GottStrafeEngland", "Howitzers", "Jihad", "KaiserGold", "Kaiserschlacht", "LeninTrain", "MaxHoffmann", "PolivanovDismissed", "RussianCode", "Senussi","SevastopolShelling", "Wassmuss"}
cp.luaData.highevents = {"AHPlanning", "AthensBombarded", "BlockadeBroken", "BringHindenburg", "Bruchmuller", "CedeTsingtao", "Colmar", "Ersatz", "EssenStrike", "Fokker", "FrenchColonies", "GeneralGov",  "GreeceCP", "IndiaRevolt", "MisharvestEnd","RailroadTurkey", "Redeploy", "RussoJapWar", "Scandal", "Spy", "TrentoCeded",  "VenizelosMurder", "WinOverRomania"} 
cp.luaData.medevents = {"ArthurBopp", "AustrianSubs", "Burstyn", "CrownPrince","CPCooperate", "CPscience", "DardanellesClosed",  "EasterRising",  "GermanColonies", "GermanMinority", "GottStrafeEngland2", "Greece1", "Hutier", "KingdomPoland", "Kriegsanleihe", "PersianBorder", "UltimatumBelgium"}

--- german AI warplans removed from probability tables because of new difficulty options

impassable.luaData.artysound = 0
impassable.luaData.winter = 0
impassable.luaData.mud = 0
impassable.luaData.convoyfactor = 0.1 * (math.random(1,10))
impassable.luaData.civwar = 0

impassable.luaData.winterfourteen = math.random(1,6)
impassable.luaData.winterfifteen = math.random(1,6)
impassable.luaData.wintersixteen = math.random(1,6)
impassable.luaData.winterseventeen = math.random(1,6)
impassable.luaData.wintereighteen = math.random(1,6)

impassable.luaData.springfifteen = math.random(1,6)
impassable.luaData.springsixteen = math.random(1,6)
impassable.luaData.springseventeen = math.random(1,6)
impassable.luaData.springeighteen = math.random(1,6)

impassable.luaData.mudlucka = 0
impassable.luaData.mudluckb = 0
impassable.luaData.mudluckc = 0
impassable.luaData.mudluckd = 0

impassable.luaData.mudfifteen = 0
impassable.luaData.mudsixteen = 0
impassable.luaData.mudseventeen = 0
impassable.luaData.mudeighteen = 0

local luck = math.random(1,100) 
if luck >= 50 then
	impassable.luaData.mudlucka = math.random(1,3)
	local luck = math.random(1,4) 
		if luck == 1 then
			impassable.luaData.mudfifteen = 3
		elseif luck == 2 then
			impassable.luaData.mudfifteen = 4
		elseif luck == 3 then
			impassable.luaData.mudfifteen = 10	
		elseif luck == 4 then
			impassable.luaData.mudfifteen = 11	
		end
end		
local luck = math.random(1,100) 
if luck >= 50 then
	impassable.luaData.mudluckb = math.random(1,3)
	local luck = math.random(1,4) 
		if luck == 1 then
			impassable.luaData.mudsixteen = 3
		elseif luck == 2 then
			impassable.luaData.mudsixteen = 4
		elseif luck == 3 then
			impassable.luaData.mudsixteen = 10	
		elseif luck == 4 then
			impassable.luaData.mudsixteen = 11	
		end
end		
local luck = math.random(1,100) 
if luck >= 50 then
		impassable.luaData.mudluckc = math.random(1,3)
		local luck = math.random(1,4) 
		if luck == 1 then
			impassable.luaData.mudseventeen = 3
		elseif luck == 2 then
			impassable.luaData.mudseventeen = 4
		elseif luck == 3 then
			impassable.luaData.mudseventeen = 10	
		elseif luck == 4 then
			impassable.luaData.mudseventeen = 11	
		end
end	
local luck = math.random(1,100) 
if luck >= 50 then
	impassable.luaData.mudluckd = math.random(1,3)
	local luck = math.random(1,4) 
		if luck == 1 then
			impassable.luaData.mudeighteen = 3
		elseif luck == 2 then
			impassable.luaData.mudeighteen = 4
		elseif luck == 3 then
			impassable.luaData.mudeighteen = 10	
		elseif luck == 4 then
			impassable.luaData.mudeighteen = 11	
		end
end	

LogUi("END PRE-GAME LUA DEFINITIONS")


end








---

 
 
if game.turn >=1 then 




---------------------------------------------------

	
local entente =  game:GetAllianceById(1)
local cp =  game:GetAllianceById(2)
local neutrals =  game:GetAllianceById(0)

 
 local france = game:GetFactionById(0)
 local britain = game:GetFactionById(1)
 local germany = game:GetFactionById(2)
 local austria = game:GetFactionById(3)
 local turkey = game:GetFactionById(5)
 local russia = game:GetFactionById(4)
 local serbia = game:GetFactionById(7)
 local italy = game:GetFactionById(8)
 local usa = game:GetFactionById(10)
 local greece = game:GetFactionById(14)
 local romania = game:GetFactionById(18)
 local bulgaria = game:GetFactionById(19)
 local portugal = game:GetFactionById(16)
 local netherlands = game:GetFactionById(9)

 
local convoyLosses = 0

for faction in game:GetAllianceById(1).factions do
          convoyLosses = convoyLosses + faction.luaData.statsCasualties["convoy"] 
 end
--------------



-------------
local britain = game:GetFactionById(1)


if game.date.year >= 1914 
	and game.type == Game.TYPE_SINGLE 
	and britain.alliance.id == 1 
	and player.alliance.id == 2 then
	if GetFactionMaxTransportmoves(britain) <= (game.date.year - 1911) 
		
		and math.random(1,100) < game.turn then
		britain.luaData.transportmovesMax = britain.luaData.transportmovesMax +1
		--britain:ConsumeProductionPoints(50)
	
	else
		local london = game:GetHex(79, 23)
		local counter = 0
		 local hexes = game.map:GetHexesInRange(london, 4)
		for _, hex in pairs(hexes) do
			if hex.terrain.type == Terrain.LAND 
				and hex.originalFaction.id == 1  
				and hex.unit ~= nil 
				and hex.unit.faction.id == 1 
				and hex.unit.prototype.name == "infantry" then
				counter = counter +1
			end	
		end
			if counter >= 3 
				and GetFactionMaxTransportmoves(britain) < counter 
				and math.random(1,100) < game.turn then
				britain.luaData.transportmovesMax = britain.luaData.transportmovesMax +1
			end
	end
	LogUi("BRITISHTRANSPORT CAPACITY:" .. britain.luaData.transportmovesMax)

end
local russia = game:GetFactionById(4)									
									
----labs check


local enttechlabs = 0
local cptechlabs = 0
	
for alliance in game.alliances do
			
			for faction in alliance.factions do					
					
					if faction.alliance.id == 1 then
					enttechlabs = enttechlabs + GetResearchUpkeep(faction)
					
					elseif faction.alliance.id == 2 then
					
					cptechlabs = cptechlabs + GetResearchUpkeep(faction)
					
					end
					
					
			end	
end	
LogUi("ENTENTE LAB COST TOTAL: " .. enttechlabs .. " CP LAB COST TOTAL: " .. cptechlabs)
	
if (enttechlabs) > (cptechlabs * 3) and game.type == Game.TYPE_SINGLE and player.alliance.id == 2 then
	germany.luaData.techbehind = 1
	austria.luaData.techbehind = 1

else
	germany.luaData.techbehind = 0
	austria.luaData.techbehind = 0

end

if (germany.luaData.techbehind == 1 or austria.luaData.techbehind == 1) and game.type == Game.TYPE_SINGLE and player.alliance.id == 2 then
	if germany.luaData.techbehind == 1 then
			germany:ConsumeProductionPoints(math.random(0,(math.ceil(math.sqrt(enttechlabs - cptechlabs)))))
			if germany.pp < 0 then
				germany:ConsumeProductionPoints(- (germany.pp))	
			end
			
			germany:ConsumeManpower(math.random(0, (math.ceil(math.sqrt(enttechlabs - cptechlabs)))))
			if GetEvent("ObsoleteWeapons") == 0 or GetEvent("UptoDateWeapons") >0 then
				SetEvent("ObsoleteWeapons", game.turn)
			end
			if germany.pp < 0 then
				germany:ConsumeProductionPoints(- (0 - germany.pp))	
			end
			
			
	end

		if austria.luaData.techbehind == 1 then
		austria:ConsumeProductionPoints(math.random(0,(math.ceil(math.sqrt(enttechlabs - cptechlabs)))))
		austria:ConsumeManpower(math.random(0, (math.ceil(math.sqrt(enttechlabs - cptechlabs)))))
				

				if GetEvent("ObsoleteWeapons") == 0 or GetEvent("UptoDateWeapons") >0 and GetEvent("ObsoleteWeapons") ~= game.turn then
					SetEvent("ObsoleteWeapons", game.turn)
				end
				if austria.pp < 0 then
					austria:ConsumeProductionPoints(- (0 - austria.pp))	
				end
				
		end

elseif germany.luaData.techbehind == 0 
	and austria.luaData.techbehind == 0 
	and GetEvent("ObsoleteWeapons") > 0 
	and (GetEvent("UptoDateWeapons") >=0 
	and GetEvent("UptoDateWeapons") < GetEvent("ObsoleteWeapons")) then
		SetEvent("UptoDateWeapons", game.turn)

end

	
local francelabo = GetTotalLabs(france)
local britainlabo = GetTotalLabs(britain)
local germanylabo = GetTotalLabs(germany)
local austrialabo = GetTotalLabs(austria)
local russialabo = GetTotalLabs(russia)
local turkeylabo = GetTotalLabs(turkey)
local italylabo = GetTotalLabs(italy)
local usalabo = GetTotalLabs(usa)
local serbialabo = GetTotalLabs(serbia)


--LogUi("!!!ENTENTE LABS!!! France:" .. francelabo.. "/ Britain:" .. britainlabo .. "/ Russia:" .. russialabo .. "/Italy:" .. italylabo .. "/USA:" .. usalabo .. "/SERBIA:" .. serbialabo)
--LogUi("!!!CP LABS!!! Germany:" .. germanylabo.. "/ Austria:" .. austrialabo .. "/ Turkey:" .. turkeylabo)									
									
  
  
end  
  
end

function FactionMoraleCalculation(faction)
  local maxProduction = 0
  for f in game.factions do
    for construction in f.constructions do
      if construction.type ~= Construction.TYPE_PORT and construction.hex.originalFaction.id == faction.id then
        maxProduction = maxProduction + construction.pp
      end
    end
  end

  -- +1000 to make it less fluctuating in early turns
  local kills = 0
  for _, k in pairs(faction.luaData.statsKills) do
    kills = kills + k
  end
  local casualties = 0
  for _, c in pairs(faction.luaData.statsCasualties) do
    casualties = casualties + c
  end
  local armyPerformance = (kills + 1000) / (casualties + 1000)

  local armyPotentialStrength = math.max(GetUpkeep(faction, true) * armyPerformance, GetIncomePP(faction, true)) * 100 / math.max(1, maxProduction)
  -- Never give more than 50 (100) for army strength
  armyPotentialStrength = math.min(armyPotentialStrength, 100)

  faction.morale = faction.luaData.eventMorale + armyPotentialStrength - gameplay.moraleSurrenderBase

--~   if faction.id == 21 then
--~   print(" ")
--~     print(faction.name .. " maxProduction: " .. faction.luaData.eventMorale .. " armyPotentialStrength: " .. armyPotentialStrength .. " armyPerformance: " .. armyPerformance)
--~     print(faction.name .. " eventMorale: " .. faction.luaData.eventMorale .. " armyPotentialStrength: " .. GetUpkeep(faction, true) * armyPerformance .. " faction.morale: " .. faction.morale .. " GetIncomePP: " .. GetIncomePP(faction))
--~     LogUi(faction.name .. " maxProduction: " .. faction.luaData.eventMorale .. " armyPotentialStrength: " .. armyPotentialStrength .. " armyPerformance: " .. armyPerformance)
     print(faction.name .. " Morale: " .. faction.morale)
--~   end
--	LogUi(faction.name .. " maxProduction: " .. faction.luaData.eventMorale .. " armyPotentialStrength: " .. armyPotentialStrength .. " armyPerformance: " .. armyPerformance)
--	LogUi(faction.name .. " eventMorale: " .. faction.luaData.eventMorale .. " armyPotentialStrength: " .. GetUpkeep(faction, true) * armyPerformance .. " faction.morale: " .. faction.morale .. " GetIncomePP: " .. GetIncomePP(faction))
--	LogUi(faction.name .. " maxProduction: " .. faction.luaData.eventMorale .. " armyPotentialStrength: " .. armyPotentialStrength .. " armyPerformance: " .. armyPerformance)
  faction.luaData.moraleLevel = GetMoraleLevel(faction.luaData.moraleLevel, faction.morale)
end

function GetMoralePercent(faction)
  return math.max(0, math.ceil(faction.morale * 100 / (100 - gameplay.moraleSurrenderBase)))
  --return faction.morale + (gameplay.moraleSurrenderBase * faction.morale / (100 - gameplay.moraleSurrenderBase))
end

function CheckForSurrender()

  local enemyAlliance = game:GetAllianceById(3 - game.currentAlliance.id)

  for faction in enemyAlliance.factions do
    if faction.morale <= 0 then

      --check if faction still has city
      local hasCities = false
      for construction in faction.constructions do
        hasCities = true
        break
      end

      if hasCities then
        OfferSurrender(faction)

        return true
      else
        --FIXME: should have popup?
        FactionSurrender(faction)
      end

    else

      -- Faction surrenders when all hexes are lost
      local hasHexes = false
      for _ in faction.hexes do
        hasHexes = true
      end
      if not hasHexes then
        FactionSurrender(faction)
      end

    end
  end

  -- End turn

  return false

end


function GetMoraleLevel(moraleLevel, morale)
  if morale <= 0 then
    return 0
  end
  local maxMorale = 100
  local percent = (morale) * 100 / maxMorale
  if percent > moraleLevel + 5 then
    moraleLevel = math.ceil((percent) / 10) * 10
    --moraleLevel = moraleLevel + 10
  end
  if percent <= moraleLevel - 10 then
    moraleLevel = math.ceil((percent) / 10) * 10
    --moraleLevel = moraleLevel - 10
  end
  if moraleLevel < 0 then
    moraleLevel = 0
  end
  return moraleLevel
end


function SetFactionMorale(faction, morale)
  faction.luaData.eventMorale = morale
  FactionMoraleCalculation(faction)
end


function GetFactionTotalMorale(faction)
  return faction.morale
end


function ChangeFactionMorale(faction, change)
  faction.luaData.eventMorale = faction.luaData.eventMorale + change
  ui.resourcesPanel:Refresh()
--~   if faction.morale < 0 then
--~     faction.morale = 0
--~   end
end

-- No longer used
--~ function CombatMoraleEffect(attacker, defender, attackerLosses, defenderLosses, retreat)
--~   ChangeFactionMorale(attacker.faction, math.floor(-attackerLosses / 10))
--~   ChangeFactionMorale(defender.faction, math.floor(-defenderLosses / 10))
--~ end

-- no longer used
-- Drop from damage to cities, effect is permanent
--~ function DestructionMoraleEffect(attacker, damage)
--~   ChangeFactionMorale(attacker.faction, -damage / 10)
--~ end


-- no longer used
--~ function CaptureMoraleEffect(captor, construction)
--~   if construction.type == Construction.TYPE_CITY or construction.type == Construction.TYPE_FORTRESS then
--~     -- morale loss for original owner
--~     local owner = construction.hex.originalFaction
--~     ChangeFactionMorale(owner, -100)

--~     -- morale boost for captor's factions
--~     for faction in captor.factions do
--~       ChangeFactionMorale(faction, 50)
--~     end
--~   elseif construction.type == Construction.TYPE_CAPITAL then
--~     -- morale loss for original owner
--~     local owner = construction.hex.originalFaction
--~     ChangeFactionMorale(owner, -200)

--~     -- morale boost for captor's factions
--~     for faction in captor.factions do
--~       ChangeFactionMorale(faction, 100)
--~     end
--~   end
--~ end

function DeptMoraleEffect(faction, dept)
  ChangeFactionMorale(faction, dept)
end
