function InitRailmoves()
  for faction in game.factions do
    SetFactionRailmoves(faction, 1)
  end
end

function SetFactionRailmoves(faction, amount)

  if type(faction) == "number" then
    faction = game:GetFactionById(faction)
  end

  faction.luaData.railmovesCurrent = amount
  faction.luaData.railmovesMax = amount
end

function GetFactionRailmoves(faction)
  return(faction.luaData.railmovesCurrent)
end

function GetFactionMaxRailmoves(faction)

  return(faction.luaData.railmovesMax)

  end

function AddFactionRailmoves(faction, amount)
  faction.luaData.railmovesCurrent = faction.luaData.railmovesCurrent + amount
end

function PurchaseFactionRailmoves(faction)
  local cost = GetRailmovesIncrementCost(GetFactionMaxRailmoves(faction))
  if faction.pp >= cost then
    faction:ConsumeProductionPoints(cost)
    faction.luaData.railmovesMax = faction.luaData.railmovesMax + 1
				if playerAlliance.luaData.railsound == 0 then
					sfx = LoadSample("railsound.wav")
					PlaySample(sfx)
					playerAlliance.luaData.railsound = 1
				end

   return true
  else
    return false
  end
end

function GetRailmovesIncrementCost(currentAmount)
  local cost = 25 * (currentAmount + 1)
  return cost
end

function ResetRailmoves()
  for faction in game.factions do
   faction.luaData.railmovesCurrent = faction.luaData.railmovesMax

  end
local austria = game:GetFactionById(3)
local russia = game:GetFactionById(4)

if GetEvent("AHPlanning") >0 and GetEvent("DOWgermany") == 0 and game.date.year == 1914 then
--LogUi("OK")
--UseRailmove(austria)
-- austria.luaData.railmovesCurrent = 0
 ui.resourcesPanel:Refresh()
end 
end

function UseRailmove(faction)

  if  faction.luaData.railmovesCurrent >0 then
  faction.luaData.railmovesCurrent = faction.luaData.railmovesCurrent - 1
	else
--LogUi("RAILMOVE DEDUCT ERROR ")
	return false
  end
  end
