class 'LoadingMenuScreen' (GameScreen)

function LoadingMenuScreen:__init()
  GameScreen.__init(self)
end

function LoadingMenuScreen:OnInit()

  tipsCount = 20

  self.hud:Load(hud.menu_loading)

  -- Draw background & hi-res bar edges
  local bg = self.hud:GetPanel("loading_panel")
  local temp = bg:GetImage("background")
  local date = GetDate()
  local date11 = false
  if (date.day == 11 and date.month == 11) then
    date11 = true
  end
  local date28 = false
  if (date.day == 28 and date.month == 7) then
    date28 = true
  end
  
  if engine.window.width / engine.window.height > 1.5 then
    if date28 then
	   temp:SetImage("graphics/hud","menu_background_wide_22.png")	
	 
	elseif date11 then	
		 temp:SetImage("graphics/hud","menu_background_wide_11.png")
	
	else
		temp:SetImage("graphics/hud","menu_background_wide.png")
	end
	
  else
	if date28 then
		temp:SetImage("graphics/hud","menu_background_22.png")
	
    elseif date11 then
		temp:SetImage("graphics/hud","menu_background_11.png")
    
	else
		temp:SetImage("graphics/hud","menu_background.png")
	end
  end
  temp:SetScaling(engine.window.width / bg.width, engine.window.height / bg.height)
  temp = bg:GetImage("menu_hiresbarleft_image")
  temp:SetPosition(0, engine.window.height-18)
  temp = bg:GetImage("menu_hiresbarright_image")
  temp:SetPosition(engine.window.width-1024, engine.window.height-18)
  temp = bg:GetImage("loading_bar")
  temp:SetPosition((engine.window.width - 1024) / 2, engine.window.height - 40)
  temp = bg:GetText("loading_text")
  temp:SetPosition(engine.window.width / 2, engine.window.height - 27)
  temp = bg:GetImage("loading_tip_bar")
  temp:SetPosition(engine.window.width / 2 - 376, engine.window.height - 160)
  temp = bg:GetText("loading_tip")
  temp:SetPosition(engine.window.width / 2, engine.window.height - 150)
--math.randomseed(os.clock()*100000000000)
 --LogUi("HUHU!")
  temp:SetLocalText("loading_tip_" .. math.random(1, tipsCount))

  self.waitPanel = self.hud:AdoptWidget(WaitingPanel())
  self.waitPanel:SetPosition((engine.window.width-self.waitPanel.width)/2, (engine.window.height-self.waitPanel.height)/2)
  self.waitPanel.descr:SetLocalText("loading_wait")

end


function LoadingMenuScreen:OnEnter()
  local luck = math.random(1,20)	
  self.hud:GetPanel("loading_panel"):GetText("loading_tip"):SetLocalText("loading_tip_" .. luck)
  self.waitPanel:Show()
end

function LoadingMenuScreen:OnExit()

end


