class 'MainMenuScreen' (GameScreen)

function MainMenuScreen:__init()
  GameScreen.__init(self)
end

function MainMenuScreen:OnInit()

  self.hud:Load(hud.menu_main)


  -- Draw background & hi-res bar edges
  local bg = self.hud:GetPanel("main_panel")
  local temp = bg:GetImage("background")
  local date = GetDate()
  local date11 = false
  if (date.day == 11 and date.month == 11) then
    date11 = true
  end
  local date28 = false
  if (date.day == 28 and date.month == 7) then
    date28 = true
  end
  
  if engine.window.width / engine.window.height > 1.5 then
    if date28 then
	   temp:SetImage("graphics/hud","menu_background_wide_22.png")	
	 
	elseif date11 then	
		 temp:SetImage("graphics/hud","menu_background_wide_11.png")
	
	else
		temp:SetImage("graphics/hud","menu_background_wide.png")
	end
	
  else
	if date28 then
		temp:SetImage("graphics/hud","menu_background_22.png")
	
    elseif date11 then
		temp:SetImage("graphics/hud","menu_background_11.png")
    
	else
		temp:SetImage("graphics/hud","menu_background.png")
	end
  end
  temp:SetScaling(engine.window.width / bg.width, engine.window.height / bg.height)
  temp = bg:GetImage("menu_hiresbarleft_image")
  temp:SetPosition(0, engine.window.height-18)
  temp = bg:GetImage("menu_hiresbarright_image")
  temp:SetPosition(engine.window.width-1024, engine.window.height-18)


  local temp = self.hud:CreateWidget(hud.menu_bar)
  temp:SetPosition((engine.window.width - 1024) / 2, engine.window.height - 40)
  

MusicPlayer():Stop()
MusicPlayer():ClearPlayList() 
StopAllSounds()

  IntroMusic()
  

end

function IntroMusic()
--reloadcheat = 0
--local atime  = os.time()
--LogUi("it is now:" .. atime)
--math.randomseed(os.clock()*atime)
--local weirdnumber = math.random(0, atime)	
--math.randomseed( os.time() ) ---old
math.randomseed( tonumber(tostring(os.time()):reverse():sub(1,6)) )
	math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();
	math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();
	math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();	
	math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();
	math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();
	math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();math.random();	
  local aluck = math.random(1,100)
  local bluck = math.random(1,100)
  local cluck = math.random(1,100)
  LogUi("ALUCK " .. aluck)
  LogUi("BLUCK " .. bluck)
  LogUi("CLUCK " .. cluck)

  local date = GetDate()
  local date11 = false
  if (date.day == 11 and date.month == 11) then
    date11 = true
  end
  if (date.day == 28 and date.month == 7) then
    date28 = true
  end

if (cluck >= 55 and cluck <= 59) or date28 == true then
	MusicPlayer():AddToPlayList("strange")
	MusicPlayer():SetLooping(true)
	MusicPlayer():Play()

elseif (cluck  >= 60 and cluck <= 64) or date11 == true then
	MusicPlayer():AddToPlayList("foreboding")
	MusicPlayer():SetLooping(true)
	MusicPlayer():Play()
	
elseif cluck >= 80 and cluck <= 84 then
	MusicPlayer():AddToPlayList("suffering")
	MusicPlayer():SetLooping(true)
	MusicPlayer():Play()	

elseif cluck <= 4 or cluck >= 96 then
	MusicPlayer():AddToPlayList("wartime")
	MusicPlayer():SetLooping(true)
	MusicPlayer():Play()	

 
elseif aluck <= 50 then
			if bluck <= 33 then
				MusicPlayer():AddToPlayList("austria")
				MusicPlayer():SetLooping(true)
				MusicPlayer():Play()

			elseif bluck <= 66 then
				MusicPlayer():AddToPlayList("main_menu")
				MusicPlayer():SetLooping(true)
				MusicPlayer():Play()
			else
				MusicPlayer():AddToPlayList("turkey")
				MusicPlayer():SetLooping(true)
				MusicPlayer():Play()
			
			end
	
else
		if cluck <= 20 then
		
			MusicPlayer():AddToPlayList("france")
			MusicPlayer():SetLooping(true)
			MusicPlayer():Play()
  
		elseif cluck <= 40 then 
  
			MusicPlayer():AddToPlayList("russia")
			MusicPlayer():SetLooping(true)
			MusicPlayer():Play()
  
		elseif cluck <= 60 then

			MusicPlayer():AddToPlayList("britain")
			MusicPlayer():SetLooping(true)
			MusicPlayer():Play()
			
		elseif cluck <= 80 then

			MusicPlayer():AddToPlayList("italy")
			MusicPlayer():SetLooping(true)
			MusicPlayer():Play()	
		else
			MusicPlayer():AddToPlayList("serbia")
			MusicPlayer():SetLooping(true)
			MusicPlayer():Play()
		
		
		end
end  
  
  MusicPlayer():SetLooping(true)
  MusicPlayer():Play()
  --[[
      there are also: Stop() and ClearPlayList(),
      use them when going to/from game
  ]]--
end



function MainMenuScreen:OnEnter()

  -- Highlight selected language flag icon
  local language = GetUserString("lang", "english")
  if language == "english" then
    self.hud:GetImage("language_english"):SetImage("graphics/hud/flags", "english_sel.png")
    self.hud:GetImage("language_german"):SetImage("graphics/hud/flags", "german.png")
    self.hud:GetImage("language_italian"):SetImage("graphics/hud/flags", "italian.png")
    self.hud:GetImage("language_french"):SetImage("graphics/hud/flags", "french.png")
  elseif language == "german" then
    self.hud:GetImage("language_english"):SetImage("graphics/hud/flags", "english.png")
    self.hud:GetImage("language_german"):SetImage("graphics/hud/flags", "german_sel.png")
    self.hud:GetImage("language_italian"):SetImage("graphics/hud/flags", "italian.png")
    self.hud:GetImage("language_french"):SetImage("graphics/hud/flags", "french.png")
  elseif language == "italian" then
    self.hud:GetImage("language_english"):SetImage("graphics/hud/flags", "english.png")
    self.hud:GetImage("language_german"):SetImage("graphics/hud/flags", "german.png")
    self.hud:GetImage("language_italian"):SetImage("graphics/hud/flags", "italian_sel.png")
    self.hud:GetImage("language_french"):SetImage("graphics/hud/flags", "french.png")
  elseif language == "french" then
    self.hud:GetImage("language_english"):SetImage("graphics/hud/flags", "english.png")
    self.hud:GetImage("language_german"):SetImage("graphics/hud/flags", "german.png")
    self.hud:GetImage("language_italian"):SetImage("graphics/hud/flags", "italian.png")
    self.hud:GetImage("language_french"):SetImage("graphics/hud/flags", "french_sel.png")
  end
end

function MainMenuScreen:OnExit()


end


