hud.menu_bar =
{
    name = "main_bar",
    type = "panel",

    controls =
    {
      {
        type = "image",
        name = "menu_bar_image",
        --position = {100, 200},
        image = "menu_bar_default",
        source = {0, 0, 1024, 40}
      },
	    {
		    name = "singleplayer_label",
		    font = "menu_font",
		    rect = {87, 12, 0, 0},
		    align = "center",
		    normal   = {199, 195, 190},
		    hilight  = {255, 255, 255},
		    select   = {255, 255, 255},
		    disabled = {50, 50, 50},
		    text = "menu_singleplayer",
		    --sfx = "click",
		    Clicked = function(this)
		      engine:SetScreen(screens.singleplayerMenu)
          PlaySample(sClick)
		    end
	    },
	    {
		    name = "multiplayer_label",
		    font = "menu_font",
		    rect = {297, 12, 0, 0},
		    align = "center",
		    normal   = {199, 195, 190},
		    hilight  = {255, 255, 255},
		    select   = {255, 255, 255},
		    disabled = {50, 50, 50},
		    text = "menu_multiplayer",
		    --sfx = "click",
		    Clicked = function(this)
		      engine:SetScreen(screens.multiplayerMenu)
					--MenuPopup(engine.screen, "Coming soon")
          PlaySample(sClick)
		    end
	    },
	    {
		    name = "options_label",
		    font = "menu_font",
		    rect = {507, 12, 0, 0},
		    align = "center",
		    normal   = {199, 195, 190},
		    hilight  = {255, 255, 255},
		    select   = {255, 255, 255},
		    disabled = {50, 50, 50},
		    text = "menu_options",
		    --sfx = "click",
		    Clicked = function(this)
		      engine:SetScreen(screens.optionsMenu)
					--MenuPopup(engine.screen, "Coming soon")
          PlaySample(sClick)
		    end
	    },
	    {
		    name = "credits_label",
		    font = "menu_font",
		    rect = {717, 12, 0, 0},
		    align = "center",
		    normal   = {199, 195, 190},
		    hilight  = {255, 255, 255},
		    select   = {255, 255, 255},
		    disabled = {50, 50, 50},
		    text = "menu_credits",
		    --sfx = "click",
		    Clicked = function(this)
		      engine:SetScreen(screens.creditsMenu)
          PlaySample(sClick)
		    end
	    },
	    {
		    name = "quit_label",
		    font = "menu_font",
		    rect = {927, 12, 0, 0},
		    align = "center",
		    normal   = {199, 195, 190},
		    hilight  = {255, 255, 255},
		    select   = {255, 255, 255},
		    disabled = {50, 50, 50},
		    text = "menu_quit",
		    --sfx = "click",
		    Clicked = function(this)
		      --engine:SetScreen(screens.quitMenu)
          engine:Close()
		    end
	    },
	    {
		    name = "language_english",
        type = "image",
		    position = {426, -30},
        image = "flags/english",
        tooltip = "no_translate.lang_english",
		    Clicked = function(this)

            engine:ChangeLang("english")
 
		    end
	    },
	    {
		    name = "language_german",
        type = "image",
		    position = {466, -30},
        image = "flags/german",
        tooltip = "no_translate.lang_german",
		    Clicked = function(this)
          
            engine:ChangeLang("german")
         
		    end
	    },
	    {
		    name = "language_italian",
        type = "image",
		    position = {506, -30},
        image = "flags/italian",
        tooltip = "no_translate.lang_italian",
		    Clicked = function(this)
          
            engine:ChangeLang("italian")
         
		    end
	    },
	    {
		    name = "language_french",
        type = "image",
		    position = {546, -30},
        image = "flags/french",
        tooltip = "no_translate.lang_french",
		    Clicked = function(this)
          
            engine:ChangeLang("french")
          
		    end
	    },
    }
}
