hud.menu_multi =
{
  ui =
  {
    name = "main_panel",
    type = "panel",
    position = {0, 0},
    image = "menu-sp",

    tooltip =
    {
      rect  = {10, 10, 0, 0},
      --color = (255 255 255),
      --bgcolor = (10 10 10),
      font  = "hud_font"
    },

    controls =
    {
	    {
		    name = "singleplayer_label",
		    font = "menu_font",
		    rect = {87, 740, 0, 0},
		    align = "center",
		    normal   = {199, 195, 190},
		    hilight  = {199, 195, 190},
		    select   = {199, 195, 190},
		    disabled = {50, 50, 50},
		    text = "menu_singleplayer",
		    sfx = "click"
	    },
	    {
		    name = "multiplayer_label",
		    font = "menu_font",
		    rect = {297, 740, 0, 0},
		    align = "center",
		    normal   = {176, 168, 155},
		    hilight  = {199, 195, 190},
		    select   = {199, 195, 190},
		    disabled = {50, 50, 50},
		    text = "menu_multiplayer",
		    sfx = "click"
	    },
	    {
		    name = "options_label",
		    font = "menu_font",
		    rect = {507, 740, 0, 0},
		    align = "center",
		    normal   = {176, 168, 155},
		    hilight  = {199, 195, 190},
		    select   = {199, 195, 190},
		    disabled = {50, 50, 50},
		    text = "menu_options",
		    sfx = "click"
	    },
	    {
		    name = "credits_label",
		    font = "menu_font",
		    rect = {717, 740, 0, 0},
		    align = "center",
		    normal   = {176, 168, 155},
		    hilight  = {199, 195, 190},
		    select   = {199, 195, 190},
		    disabled = {50, 50, 50},
		    text = "menu_credits",
		    sfx = "click"
	    },
	    {
		    name = "quit_label",
		    font = "menu_font",
		    rect = {927, 740, 0, 0},
		    align = "center",
		    normal   = {176, 168, 155},
		    hilight  = {199, 195, 190},
		    select   = {199, 195, 190},
		    disabled = {50, 50, 50},
		    text = "menu_quit",
		    sfx = "click"
	    },

	    {
		    name = "selectCampaign_text",
		    font = "menu_font",
		    rect = {65, 430, 0, 0},
		    align = "left",
		    color   = {176, 168, 155},
		    text = "select_campaign",
	    },
	    {
		    name = "mission_list",
		    rect = {65, 461, 200, 200},
		    item_color = {176, 168, 155, 255},
		    select_color = {96, 82, 73, 200},
		    font = "menu_font",
		    spacing = 16,
		    sfx = "click"
	    },
	    {
		    name  = "info_memo",
		    image = "campaign_description",
		    position  = {460, 150},
		    font  = "verdana12_font",
		    color = {0, 0, 00},
			shadow = {offset = {0, 0}},
		    text  = "campaignSelect",
		    border = 10
	    },

	    {
		    name = "selectAlliance_text",
		    font = "menu_font",
		    rect = {469, 368, 0, 0},
		    align = "left",
		    color   = {176, 168, 155},
		    text = "select_alliance",
	    },
	    {
	    	name = "alliance_list",
	    	rect = {469, 399, 200, 20},
	    	item_color = {176, 168, 155, 255},
	    	select_color = {96, 82, 73, 200},
	    	font = "menu_font",
		    spacing = 16,
		    sfx = "click"
	    },
	    {
		    name = "selectDifficulty_text",
		    font = "menu_font",
		    rect = {469, 492, 0, 0},
		    align = "left",
		    color   = {176, 168, 155},
		    text = "difficulty",
		    sfx = "click"
	    },
	    {
		    name = "difficulty_list",
		    rect = {469, 523, 200, 200},
		    item_color = {176, 168, 155, 255},
		    select_color = {96, 82, 73, 200},
		    font = "menu_font",
		    spacing = 16,
		    sfx = "click"
	    },
        {
		    name = "launch_label",
		    font = "menu_font",
		    rect = {469, 647, 0, 0},
		    align = "left",
		    normal   = {176, 168, 155},
		    hilight  = {255, 255, 255},
		    select   = {255, 255, 255},
		    disabled = {50, 50, 50},
		    text = "launch",
		    sfx = "click"
	    },
    }
  }
}
