function SaveGame(save)
--~   save.version = self.SaveVersion -- always to latest ver
--~   [save all data]


  engine:SaveGame(save)
end



function LoadGame(save)
--~   if save.version == nil -- current unversioned version
--~     self:LoadSaveV1(save)
--~   end
--~   if save.version < 3 then
--~     self:LoadSavePreV3(save) -- deal with missing variables
--~   else if (..)
--~   [...]

  engine:LoadSingleplayerGame(save)

  --if game.type ~= Game.TYPE_PBEM then
  --end

  -- Save compatibilities --
  --------------------------

  -- Morale: faction.luaData.eventMorale

  -- ugly hack to erase saved event popups from previous turn
  gameLoaded = true

  
  
end

function OnFactionLoad(faction)
  if faction.luaData.eventMorale == nil then
    LogUi("eventMorale fix")
    faction.luaData.eventMorale = faction.morale
  end

  if faction.luaData.transportmovesCurrent == nil then
    LogUi("transport capacity fix")
    local amountByFaction = {
    [0] = 1,--France
    [1] = 3,--Britain
    [2] = 1,--Germany
    [3] = 1,--Austria
    [10] = 2--USA
    }
    local amount = amountByFaction[faction.id]
    if amount == nil then
      amount = 0
    end
    SetFactionTransportmoves(faction, amount)
  end

end

